#pragma once

// Specific includes needed by this class
#include "KnownFile.h"

#define OP_LANCASTPROT			0xC6

#define OP_HASH					0x01		// Broadcast hash
#define OP_HASHSEARCH			0x02		// Search the subnet for a hash
#define OP_HASHSEARCHRESPONCE	0x03		// Hash found on this client
#define OP_FILESEARCH			0x04		// Search the subnet for a file
#define OP_FILESEARCHRESPONCE	0x05		// File found on this client

// CLanCast command target

class CLanCast : public CAsyncSocket
{

public:
	CLanCast(CPreferences* in_prefs);
	~CLanCast();

	virtual void OnReceive(int nErrorCode);
	bool SendPacket(Packet* packet);

	void CLanCast::Start();
	void CLanCast::Stop();

	void CLanCast::BroadcastHash(CKnownFile* cur_file);

private:

void CLanCast::RecieveHash(char* pachPacket, uint32 nSize);

	BOOL JoinGroup(CString, UINT, UINT, BOOL);
	BOOL LeaveGroup();

	void SetLoopBack(BOOL);
	BOOL SetTTL(UINT nTTL);
	BOOL CreateSendingSocket(UINT, BOOL);
	BOOL CreateReceivingSocket(LPCTSTR, UINT);

	void static CALLBACK UDPTimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
	bool CLanCast::ProcessPacket(char* packet, uint32 size, uint8 opcode);
		//(char* packet, int16 size, int8 opcode, char* host, uint16 port);

private:

	SOCKADDR_IN m_saHostGroup;	// SOCKADDR structure to hold IP/Port of the Host group to send data to it
	ip_mreq m_mrMReq;			// Contains IP and interface of the host group

	CAsyncSocket m_SendSocket;	// Socket for sending data to the host group

	bool bStarted;
	uint32 udp_timer;												// Timer to fire packet sends

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	CPreferences* prefs;											// Pointer to the preferences object

	bool GetLancastEnabled()		{return prefs->GetLancastEnabled();}	// Settings
	uint32 GetLancastIP()			{return prefs->GetLancastIP();}
	uint32 GetLancastSubnet()		{return prefs->GetLancastSubnet();}
	uint16 GetLancastPort()			{return prefs->GetLancastPort();}
	uint16 GetEmulePort()			{return prefs->GetPort();}					// Current Emule Listening Port

};

