#pragma once
#include "types.h"
#include "MuleListCtrl.h"


class	CListCtrlSorterItem
{
friend class CListCtrlSorter;

public:
	CListCtrlSorterItem(uint8 id) : m_id(id) { set(); }
	
	void	set(uint8 levels=1, bool reverse=false, bool defaultDir=true, bool defaultLevel=1);
	void	clicked(uint8 id);
	CMuleListCtrl::ArrowType arrow();


protected:
	uint8	m_level;
	bool	m_dir;
	bool	m_reverse;


private:
	uint8	m_id;

	uint8	m_levels;

	uint8	m_defaultLevel;
	bool	m_defaultDir;
};



class	CListCtrlSorter
{
public:
	CListCtrlSorter();
	~CListCtrlSorter();
	
	void						init(uint8 items);
	CListCtrlSorterItem*		item(uint8 item)	{ return m_items[item]; }
	void						clicked(uint8 id)	{ m_items[id]->clicked(m_selected); m_selected=id; }
	bool						dir()				{ return m_items[m_selected]->m_dir ^ m_items[m_selected]->m_reverse; }
	uint8						level()				{ return m_items[m_selected]->m_level; }
	uint8						selected()			{ return m_selected; }
	CMuleListCtrl::ArrowType	arrow()				{ return m_items[m_selected]->arrow(); }

private:
	uint8					m_itemc;
	CListCtrlSorterItem**	m_items;
	uint8					m_selected;
};



