//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// Mod_Version.h version2

//#include "KnownFile.h"
//#include <math.h>

//#include "otherfunctions.h"
//#include "emule.h"
#include "stdafx.h"
#include "emule.h"
#include "Mod_Version.h"
#include "otherfunctions.h"
#include "opcodes.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CModVersion::CModVersion()
{
;
}
CModVersion::~CModVersion()
{
;
}

void CModVersion::Mod_Version_String (CUpDownClient *client, CString *buffer)
{
	//CString buffer;
	//LSD Version
		switch(client->GetClientSoft()){
			case SO_EMULE:
			case SO_OLDEMULE:{
				buffer->Format("eMule v%02X", client->GetMuleVersion());
				// Added by Tarod -checks for Plus or Tarod versions
				if (client->IsTarodVersion()) {
					if (client->GetTarodVersionNumber() > 0) {
						buffer->AppendFormat(" [Tarod.%03x", client->GetTarodVersionNumber());
						if (buffer->Right(1)=="0")
							buffer->Delete(strlen(*buffer)-1, 1);
						buffer->AppendFormat("]");
					}
					else {
						buffer->AppendFormat( "%s", " [Mod]"); //is Old Advanced Mod
				}
				//LSD Ver
				if (client->IsLSDVersion()) { //LSD version, thnks Tarod
					buffer->Format("eMule v%02X", client->GetMuleVersion());
						if (client->GetLSDVersionNumber() > 0) {
							buffer->AppendFormat(" [LSD.%03x]", client->GetLSDVersionNumber());
							buffer->Remove ('0');
						}
						else {
							buffer->AppendFormat( "%s", " [LSD]");
						}
				} else //Plus Ver
				if (client->IsPLUSVersion()) { //Plus version
					buffer->Format("eMule v%02X", client->GetMuleVersion());
						if(client->GetPLUSVersionNumber()>0) {
							buffer->AppendFormat(" [Plus.%x%x", client->GetPLUSVersionNumber()>>8, (client->GetPLUSVersionNumber() & 0xFF)+9);
							if (buffer->Right(1)=="9")
								buffer->Delete(strlen(*buffer)-1, 1);
							buffer->AppendFormat("]");
						}
						else {
								buffer->AppendFormat( "%s", " [Plus]");
						}
				} else //Morph Ver
				if (client->IsMorphVersion()) { //Morph version
					buffer->Format("eMule v%02X", client->GetMuleVersion());
						if (client->GetMorphVersionNumber() > 0) {
							buffer->AppendFormat(" [MoRpH.%03x]", client->GetMorphVersionNumber());
							buffer->Remove ('0');
						} 
						else {
							buffer->AppendFormat( "%s", " [MoRpH]");
						}
				} else //Fusion ver
				if (client->IsFusionVersion()) { //Fusion version
					buffer->Format("eMule v%02X", client->GetMuleVersion());
						if ((client->GetFusionVersionNumber() > 0) && (client->GetFusionVersionString()!=NULL)) {
							buffer->AppendFormat(" [Fusion.%s]", client->GetFusionVersionString());
							//buffer->Remove ('0');
						} 
						else {
							buffer->AppendFormat( "%s", " [.FusioN.]");
						}
				} else //MorTillo ver
				if (client->IsMorTilloVersion()) { //MorTillo ver
		                        buffer->Format("eMule v%02X", client->GetMuleVersion());
	                        		if ((client->GetMorTilloVersionNumber() > 0) && (client->GetMorTilloVersionString()!=NULL)) {
	                        			buffer->AppendFormat(" [MorTillo.%s]", client->GetMorTilloVersionString());
	                         			//buffer.Remove ('0');
	                        		}
	                        		else {
		                        		buffer->AppendFormat( "%s", " [MorTillo]");
		                            	}
				} else //Oxygen ver
				if (client->IsOxyVersion()) { // Oxygen version
					buffer->Format("eMule v%02X [Oxygen]", client->GetMuleVersion());
				} else
				if (client->GetLovelaceVersionString()!=NULL) {
					buffer->Format("eMule v%02X", client->GetMuleVersion());
					buffer->AppendFormat(" [lovelace.%s]", client->GetLovelaceVersionString());         			
         			}
         			else				
				if (client->GetModVersion()!=NULL) { //Mod generic
		                        buffer->Format("eMule v%02X", client->GetMuleVersion());
	                        	buffer->AppendFormat(" [%s]", client->GetModVersion());
	                        } 

				}  
				
				break;	
			} //END eMule Case			
			case SO_EDONKEY:
				//buffer->Format("eDonkey v%i", client->GetVersion());
				buffer->Format("eDonkey v%.0f", (float)client->GetVersion()/10);
				break;
			case SO_EDONKEYHYBRID:
				//buffer->Format( "dHybrid v%i", client->GetVersion());
				buffer->Format( "dHybrid v%.2f", (float)client->GetVersion()/100);
				buffer->Remove ('0');
				break;
		} //END Case

}
void CModVersion::Mod_Version_Sort   (int16 &c1,int16 &c2,CUpDownClient *item1,CUpDownClient *item2)
{
			//int c1,c2;

			c1=item1->GetVersion();
			c2=item2->GetVersion();
			if(item1->IsEmuleClient())
				{
				c1=item1->GetMuleVersion();
				if (item1->IsTarodVersion())
					c1=c1+item1->GetLSDVersionNumber()+item1->GetTarodVersionNumber()+item1->GetPLUSVersionNumber()+40;
				else if (item1->IsMorphVersion() || item1->IsOxyVersion() || item1->IsFusionVersion()|| item1->IsMorTilloVersion()) {
					c1=c1+item1->GetMorphVersionNumber()+20;
					if (item1->IsFusionVersion()) c1+=5;
					}
				}
			else c1=c1+item1->GetClientSoft()-2000;
			if ((item1->GetClientSoft())==SO_UNKNOWN) c1=-8000;
			if(item2->IsEmuleClient())
				{
				c2=item2->GetMuleVersion();
				if (item2->IsTarodVersion())
					c2=c2+item2->GetLSDVersionNumber()+item2->GetTarodVersionNumber()+item2->GetPLUSVersionNumber()+40;
				else if (item2->IsMorphVersion() || item2->IsOxyVersion() || item2->IsFusionVersion() || item2->IsMorTilloVersion()) {
					c2=c2+item2->GetMorphVersionNumber()+20;
					if (item2->IsFusionVersion()) c2+=5;
					}
				}
			else c2=c2+item2->GetClientSoft()-2000;
			if ((item2->GetClientSoft())==SO_UNKNOWN) c2=-8000;
			//return c1-c2;
}

