// PPgMessaging.cpp : file di implementazione
//

#include "stdafx.h"
#include "emule.h"
#include "PPgMessaging.h"


// finestra di dialogo CPPgMessaging

IMPLEMENT_DYNAMIC(CPPgMessaging, CPropertyPage)
CPPgMessaging::CPPgMessaging()
: CPropertyPage(CPPgMessaging::IDD) {
	LoadSettings();
	Localize();
}

CPPgMessaging::~CPPgMessaging() {
}

void CPPgMessaging::DoDataExchange(CDataExchange* pDX) {
	CPropertyPage::DoDataExchange(pDX);
}

void CPPgMessaging::Localize(void) {
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_IM_OPTIONS));
		GetDlgItem(IDC_GB_IM_ACCEPT)->SetWindowText(GetResString(IDS_PW_IM_ACCEPT));
		GetDlgItem(IDC_GB_IM_OTHER)->SetWindowText(GetResString(IDS_PW_IM_OTHER));
		GetDlgItem(IDC_RB_IM_FROMALLUSERS)->SetWindowText(GetResString(IDS_PW_IM_FROMALLUSERS));
		GetDlgItem(IDC_RB_IM_ONLYFROMFRIENDS)->SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS));
		GetDlgItem(IDC_RB_IM_ONLYFROMFRIENDS2)->SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS2));
		GetDlgItem(IDC_RB_IM_FROMNONE)->SetWindowText(GetResString(IDS_PW_IM_FROMNONE));
		GetDlgItem(IDC_CB_IM_PUTMEAWAY)->SetWindowText(GetResString(IDS_PW_IM_PUTMEAWAY));
		GetDlgItem(IDC_LBL_IM_AWAYMESSAGE)->SetWindowText(GetResString(IDS_PW_IM_AWAYMESSAGE));		
	}
}

void CPPgMessaging::LoadSettings(void) {
	CEdit* editPtr;
	if(m_hWnd)
	{
		switch(app_prefs->prefs->acceptMessagesFrom) {
			case 1: //Accept messages from all users
				CheckDlgButton(IDC_RB_IM_FROMALLUSERS, BST_CHECKED);				
				break;
			case 2: //Accept messages from friends only
				CheckDlgButton(IDC_RB_IM_ONLYFROMFRIENDS, BST_CHECKED);
				break;
			case 3: //Accept messages from friends and put other user's messages
				//all in one tab
				CheckDlgButton(IDC_RB_IM_ONLYFROMFRIENDS2, BST_CHECKED);
				break;
			case 4: //Accept no message
				CheckDlgButton(IDC_RB_IM_FROMNONE, BST_CHECKED);
				break;
		}//switch acceptMessagesFrom

		if (app_prefs->prefs->awayState)
			CheckDlgButton(IDC_CB_IM_PUTMEAWAY, BST_CHECKED);

		editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
		editPtr->SetWindowText(LPCTSTR(app_prefs->prefs->awayStateMessage));

		//added by Roman2K
		CEdit* editPtr;
		editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
		editPtr->EnableWindow(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));
		if (IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY)) editPtr->SetFocus();
		//Roman2K end
	}
}

BEGIN_MESSAGE_MAP(CPPgMessaging, CPropertyPage)
	ON_BN_CLICKED(IDC_RB_IM_FROMALLUSERS, OnBnClickedRbImFromallusers)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS, OnBnClickedRbImOnlyfromfriends)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS2, OnBnClickedRbImOnlyfromfriends2)
	ON_BN_CLICKED(IDC_RB_IM_FROMNONE, OnBnClickedRbImFromnone)
	ON_EN_CHANGE(IDC_EDIT_IM_AWAYMESSAGE, OnEnChangeEditImAwaymessage)
	ON_BN_CLICKED(IDC_CB_IM_PUTMEAWAY, OnBnClickedCbImPutmeaway)
END_MESSAGE_MAP()


// gestori di messaggi CPPgMessaging

BOOL CPPgMessaging::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPPgMessaging::OnApply() {
	CEdit* editPTR;
	char buffer[255];

	if (IsDlgButtonChecked(IDC_RB_IM_FROMALLUSERS))
		app_prefs->prefs->acceptMessagesFrom=1; // Accept all messages

	if (IsDlgButtonChecked(IDC_RB_IM_ONLYFROMFRIENDS))
		app_prefs->prefs->acceptMessagesFrom=2; // Accept from friends

	if (IsDlgButtonChecked(IDC_RB_IM_ONLYFROMFRIENDS2))
		app_prefs->prefs->acceptMessagesFrom=3; // Accept from friends and put other msg in a single tab

	if (IsDlgButtonChecked(IDC_RB_IM_FROMNONE))
		app_prefs->prefs->acceptMessagesFrom=4; // Do not accept messages

	app_prefs->prefs->awayState=(int8)IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY);

	editPTR = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
	if (editPTR->GetWindowText(buffer,255)>0)
		sprintf(app_prefs->prefs->awayStateMessage,"%s",buffer);
	else
		app_prefs->prefs->awayStateMessage[0]='\0';

	//added by Roman2K
	CEdit* editPtr;
	editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
	editPtr->EnableWindow(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));
	if (IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY)) editPtr->SetFocus();
	//Roman2K end

	SetModified(FALSE);
	return CPropertyPage::OnApply();
}

void CPPgMessaging::OnBnClickedCbImPutmeaway() {
	CEdit* editPtr;
	editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
	editPtr->EnableWindow(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));
	if (IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY)) editPtr->SetFocus();
	SetModified();
}