// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgTweaks.h"
#include ".\ppgtweaks.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgTweaks dialog

IMPLEMENT_DYNAMIC(CPPgTweaks, CPropertyPage)
CPPgTweaks::CPPgTweaks()
: CPropertyPage(CPPgTweaks::IDD)
{
}

CPPgTweaks::~CPPgTweaks()
{
}

void CPPgTweaks::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgTweaks, CPropertyPage)
	ON_EN_CHANGE(IDC_MAXCON5SEC, OnSettingsChange)
	ON_BN_CLICKED(IDC_VERBOSE, OnSettingsChange)
	ON_BN_CLICKED(IDC_USECREDITSYSTEM, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOTAKEED2KLINKS, OnSettingsChange)
	ON_BN_CLICKED(IDC_DEBUG_SOURCE_EXCHANGE, OnSettingsChange) //Sony April 23. 2003, button to keep the source exchange msgs out of the verbose log

	//Added by Roman2K
	ON_EN_CHANGE(IDC_LOWIDRETRY, OnSettingsChange)	// SLUGFILLER: lowIdRetry
	ON_BN_CLICKED(IDC_INFINITEQUEUE, OnClickInfiniteQueue)	// SLUGFILLER: infiniteQueue
	//Roman2K end
	ON_BN_CLICKED(IDC_INFINITEQUEUE, OnSettingsChange)	// SLUGFILLER: infiniteQueue
	ON_BN_CLICKED(IDC_CHECKDISKSPACE, OnSettingsChange)	// SLUGFILLER: checkDiskspace
	
	ON_BN_CLICKED(IDC_CB_ENABLESLS, OnBnClickedCbEnablesls) //added by Roman2K

	ON_WM_HSCROLL()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SC_SLS_ACTIVATIONLIMIT, OnNMCustomdrawScSlsActivationlimit)
END_MESSAGE_MAP()


// CPPgTweaks message handlers


BOOL CPPgTweaks::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();


	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgTweaks::LoadSettings(void)
{
	if(m_hWnd)
	{
		CString strBuffer;

		strBuffer.Format("%d", app_prefs->GetMaxConperFive());
		GetDlgItem(IDC_MAXCON5SEC)->SetWindowText(strBuffer);

		//added by Roman2K
		// SLUGFILLER: lowIdRetry
		strBuffer.Format("%d", app_prefs->GetLowIdRetries());
		GetDlgItem(IDC_LOWIDRETRY)->SetWindowText(strBuffer);
		// SLUGFILLER: lowIdRetry
	}
		// SLUGFILLER: infiniteQueue
		if(app_prefs->prefs->infiniteQueue)
			CheckDlgButton(IDC_INFINITEQUEUE,1);
		else
			CheckDlgButton(IDC_INFINITEQUEUE,0);
		// SLUGFILLER: infiniteQueue
		//Roman2K end
	if(app_prefs->prefs->m_bVerbose)
		CheckDlgButton(IDC_VERBOSE,1);
	else
		CheckDlgButton(IDC_VERBOSE,0);

	if(app_prefs->prefs->m_bDebugSourceExchange)
		CheckDlgButton(IDC_DEBUG_SOURCE_EXCHANGE,1);
	else
		CheckDlgButton(IDC_DEBUG_SOURCE_EXCHANGE,0);

	if(app_prefs->prefs->log2disk)
		CheckDlgButton(IDC_LOG2DISK,1);
	else
		CheckDlgButton(IDC_LOG2DISK,0);
	if(app_prefs->prefs->debug2disk)
		CheckDlgButton(IDC_DEBUG2DISK,1);
	else
		CheckDlgButton(IDC_DEBUG2DISK,0);

	if(app_prefs->prefs->m_bCreditSystem)
		CheckDlgButton(IDC_USECREDITSYSTEM,1);
	else
		CheckDlgButton(IDC_USECREDITSYSTEM,0);

	// Barry
	if(app_prefs->prefs->autotakeed2klinks)
		CheckDlgButton(IDC_AUTOTAKEED2KLINKS,1);
	else
		CheckDlgButton(IDC_AUTOTAKEED2KLINKS,0);
	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetRange(1,100,true);
	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetPos(app_prefs->prefs->m_iFileBufferSize);
	m_iFileBufferSize = app_prefs->prefs->m_iFileBufferSize;
	((CSliderCtrl*)GetDlgItem(IDC_QUEUESIZE))->SetRange(20,100,true);
	((CSliderCtrl*)GetDlgItem(IDC_QUEUESIZE))->SetPos(app_prefs->prefs->m_iQueueSize);
	m_iQueueSize = app_prefs->prefs->m_iQueueSize;
	GetDlgItem(IDC_DEBUG_SOURCE_EXCHANGE)->EnableWindow(IsDlgButtonChecked(IDC_VERBOSE));

	// START enkeyDEV(kei-kun) -SLS preferences-
	if (app_prefs->prefs->m_bUseSLS)
		CheckDlgButton(IDC_CB_ENABLESLS,1);
	else
		CheckDlgButton(IDC_CB_ENABLESLS,0);

	((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT))->SetRange(1,1000,true); //IceCream, Increase the limit to save
	((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT))->SetPos(app_prefs->prefs->m_iActivationLimitSLS);
	m_iActivationLimitSLS = app_prefs->prefs->m_iActivationLimitSLS;

	((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE))->SetRange(1,100,true); //IceCream, save more best sources
	((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE))->SetPos(app_prefs->prefs->m_iSourcesToSaveSLS);
	m_iSourcesToSaveSLS = app_prefs->prefs->m_iSourcesToSaveSLS;
	// END enkeyDEV(kei-kun) -SLS preferences-

	GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));	  //added by
	GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));	  //Roman2K

	GetDlgItem(IDC_QUEUESIZE)->EnableWindow(!IsDlgButtonChecked(IDC_INFINITEQUEUE)); //added by Roman2K
	// SLUGFILLER: checkDiskspace
	if(app_prefs->prefs->checkDiskspace)
		CheckDlgButton(IDC_CHECKDISKSPACE,1);
	else
		CheckDlgButton(IDC_CHECKDISKSPACE,0);
	// SLUGFILLER: checkDiskspace
}

BOOL CPPgTweaks::OnApply()
{
	char buffer[510];
	if(GetDlgItem(IDC_MAXCON5SEC)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXCON5SEC)->GetWindowText(buffer,20);
		app_prefs->SetMaxConsPerFive((atoi(buffer)) ?
			atoi(buffer) : 20);
		theApp.scheduler->original_cons5s=app_prefs->GetMaxConperFive();
	}

	if(IsDlgButtonChecked(IDC_VERBOSE))
		app_prefs->prefs->m_bVerbose = true;
	else
		app_prefs->prefs->m_bVerbose = false;

	if(IsDlgButtonChecked(IDC_DEBUG_SOURCE_EXCHANGE))
		app_prefs->prefs->m_bDebugSourceExchange = true;
	else
		app_prefs->prefs->m_bDebugSourceExchange = false;

	// Barry
	bool be4=app_prefs->prefs->autotakeed2klinks;
	app_prefs->prefs->autotakeed2klinks = (int8)IsDlgButtonChecked(IDC_AUTOTAKEED2KLINKS);
	app_prefs->prefs->log2disk = (int8)IsDlgButtonChecked(IDC_LOG2DISK);
	app_prefs->prefs->debug2disk = (int8)IsDlgButtonChecked(IDC_DEBUG2DISK);

	if ((int8)be4!=app_prefs->prefs->autotakeed2klinks) RevertReg();

	app_prefs->prefs->m_iFileBufferSize = m_iFileBufferSize;
	app_prefs->prefs->m_iQueueSize = m_iQueueSize;

	//added by Roman2K
	// SLUGFILLER: lowIdRetry
	if(GetDlgItem(IDC_LOWIDRETRY)->GetWindowTextLength())
	{
		GetDlgItem(IDC_LOWIDRETRY)->GetWindowText(buffer,20);
		app_prefs->SetLowIdRetries(atoi(buffer));
	}
	// SLUGFILLER: lowIdRetry

	// SLUGFILLER: infiniteQueue
	if(IsDlgButtonChecked(IDC_INFINITEQUEUE))
		app_prefs->prefs->infiniteQueue = true;
	else
		app_prefs->prefs->infiniteQueue = false;
	// SLUGFILLER: infiniteQueue
	//Roman2K end

	// START enkeyDEV(kei-kun) -SLS preferences-
	if (IsDlgButtonChecked(IDC_CB_ENABLESLS))
		app_prefs->prefs->m_bUseSLS = 1;
	else
		app_prefs->prefs->m_bUseSLS = 0;
	app_prefs->prefs->m_iActivationLimitSLS = m_iActivationLimitSLS;
	app_prefs->prefs->m_iSourcesToSaveSLS = m_iSourcesToSaveSLS;
	// END enkeyDEV(kei-kun) -SLS preferences-

	GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));	   //added by
	GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));	   //Roman2K

	GetDlgItem(IDC_QUEUESIZE)->EnableWindow(!IsDlgButtonChecked(IDC_INFINITEQUEUE)); //added by Roman2K

	// SLUGFILLER: checkDiskspace
	if(IsDlgButtonChecked(IDC_CHECKDISKSPACE))
		app_prefs->prefs->checkDiskspace = true;
	else
		app_prefs->prefs->checkDiskspace = false;
	theApp.downloadqueue->CheckDiskspace();		// option updated
	// SLUGFILLER: checkDiskspace

	LoadSettings();
	SetModified(FALSE);
	theApp.emuledlg->serverwnd.ToggleDebugWindow();
	theApp.emuledlg->serverwnd.UpdateLogTabSelection();

	return CPropertyPage::OnApply();
}

void CPPgTweaks::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);

	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	if (pScrollBar==GetDlgItem(IDC_FILEBUFFERSIZE)) {
		m_iFileBufferSize = slider->GetPos();
		temp.Format( GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*15000 );
		GetDlgItem(IDC_FILEBUFFERSIZE_STATIC)->SetWindowText(temp);
	}
	else if (pScrollBar==GetDlgItem(IDC_QUEUESIZE)) {
		m_iQueueSize = slider->GetPos();
		temp.Format( GetResString(IDS_QUEUESIZE), m_iQueueSize*100 );
		GetDlgItem(IDC_QUEUESIZE_STATIC)->SetWindowText(temp);
	}

	// START enkeyDEV(kei-kun) -SLS preferences-
	else if (pScrollBar==GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT)) {
		m_iActivationLimitSLS = slider->GetPos();
		temp.Format( GetResString(IDS_ACTIVATIONLIMIT_SLS), m_iActivationLimitSLS);
		GetDlgItem(IDC_LBL_SLS_ACTIVATIONLIMIT)->SetWindowText(temp);

		if (m_iActivationLimitSLS < m_iSourcesToSaveSLS)
		{
			m_iSourcesToSaveSLS = m_iActivationLimitSLS;
			((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE))->SetPos(m_iSourcesToSaveSLS);
			temp.Format( GetResString(IDS_SOURCESTOSAVE_SLS), m_iSourcesToSaveSLS);
			GetDlgItem(IDC_LBL_SLS_SOURCESTOSAVE)->SetWindowText(temp);
		}
	}

	else if (pScrollBar==GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE)) {
		m_iSourcesToSaveSLS = slider->GetPos();
		temp.Format( GetResString(IDS_SOURCESTOSAVE_SLS), m_iSourcesToSaveSLS);
		GetDlgItem(IDC_LBL_SLS_SOURCESTOSAVE)->SetWindowText(temp);

		if (m_iSourcesToSaveSLS > m_iActivationLimitSLS)
		{
			m_iActivationLimitSLS = m_iSourcesToSaveSLS;
			((CSliderCtrl*)GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT))->SetPos(m_iActivationLimitSLS);
			temp.Format( GetResString(IDS_ACTIVATIONLIMIT_SLS), m_iActivationLimitSLS);
			GetDlgItem(IDC_LBL_SLS_ACTIVATIONLIMIT)->SetWindowText(temp);
		}
	}
	// END enkeyDEV(kei-kun) -SLS preferences-
}

void CPPgTweaks::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_TWEAK));
		GetDlgItem(IDC_MAXCON5SECLABEL )->SetWindowText(GetResString(IDS_MAXCON5SECLABEL));
		GetDlgItem(IDC_LOWIDRETRYLABEL )->SetWindowText(GetResString(IDS_LOWIDRETRYLABEL));
		//GetDlgItem(IDC_WARNING)->SetWindowText(GetResString(IDS_WARNING)); //removed by Roman2K (useless)
		GetDlgItem(IDC_AUTOTAKEED2KLINKS)->SetWindowText(GetResString(IDS_AUTOTAKEED2KLINKS));
		GetDlgItem(IDC_VERBOSE)->SetWindowText(GetResString(IDS_VERBOSE));
		GetDlgItem(IDC_DEBUG_SOURCE_EXCHANGE)->SetWindowText(GetResString(IDS_DEBUG_SOURCE_EXCHANGE));

		GetDlgItem(IDC_LOG2DISKFRAME)->SetWindowText(GetResString(IDS_LOG2DISKFRAME));
		GetDlgItem(IDC_LOG2DISK)->SetWindowText(GetResString(IDS_LOG2DISK));
		GetDlgItem(IDC_DEBUG2DISK)->SetWindowText(GetResString(IDS_DEBUG2DISK));

		CString temp;
		temp.Format( GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*15000 );
		GetDlgItem(IDC_FILEBUFFERSIZE_STATIC)->SetWindowText(temp);
		temp.Format( GetResString(IDS_QUEUESIZE), m_iQueueSize*100 );
		GetDlgItem(IDC_QUEUESIZE_STATIC)->SetWindowText(temp);

		// START enkeyDEV(kei-kun) -SLS preferences-
		GetDlgItem(IDC_GB_SLS)->SetWindowText(GetResString(IDS_SLS));
		GetDlgItem(IDC_CB_ENABLESLS)->SetWindowText(GetResString(IDS_ENABLESLS));		
		temp.Format( GetResString(IDS_ACTIVATIONLIMIT_SLS), m_iActivationLimitSLS);
		GetDlgItem(IDC_LBL_SLS_ACTIVATIONLIMIT)->SetWindowText(temp);
		temp.Format( GetResString(IDS_SOURCESTOSAVE_SLS), m_iSourcesToSaveSLS);
		GetDlgItem(IDC_LBL_SLS_SOURCESTOSAVE)->SetWindowText(temp);
		// END enkeyDEV(kei-kun) -SLS preferences-
 		GetDlgItem(IDC_INFINITEQUEUE )->SetWindowText(GetResString(IDS_INFINITEQUEUE));	// SLUGFILLER: infiniteQueue
 		GetDlgItem(IDC_CHECKDISKSPACE )->SetWindowText(GetResString(IDS_CHECKDISKSPACE));	// SLUGFILLER: checkDiskspace
	}
}

// added by Roman2K
void CPPgTweaks::OnBnClickedCbEnablesls()
{
	if (guardian) return;

	guardian=true;
	SetModified();

	GetDlgItem(IDC_SC_SLS_ACTIVATIONLIMIT)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));
	GetDlgItem(IDC_SC_SLS_SOURCESTOSAVE)->EnableWindow(IsDlgButtonChecked(IDC_CB_ENABLESLS));

	guardian=false;
}

void CPPgTweaks::OnClickInfiniteQueue()
{
	if (guardian) return;

	guardian=true;
	SetModified();

	GetDlgItem(IDC_QUEUESIZE)->EnableWindow(!IsDlgButtonChecked(IDC_INFINITEQUEUE));

	guardian=false;
}
//Roman2K end
void CPPgTweaks::OnNMCustomdrawScSlsActivationlimit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;
}
