//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "uploadqueue.h"
#include "packets.h"
#include "emule.h"
#include "knownfile.h"
#include "listensocket.h"
#include "ini2.h"
#include "math.h"
#include "Amuc.h" //added by Roman2K[Mortillo[Xmod[Herbert[Milenia[Pasq]]]]]
#include "Exceptions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


static uint32 counter, sec,statsave;
// -khaos--+++> Added iupdateconnstats...
static uint32 igraph, istats, iupdateconnstats;
// <-----khaos-

//TODO rewrite the whole networkcode, use overlapped sockets

CUploadQueue::CUploadQueue(CPreferences* in_prefs){
	app_prefs = in_prefs;
	h_timer = SetTimer(0,141,100,UploadTimer);
	if (!h_timer)
		theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_ERR_TIMERCREATEFAILED));
	estadatarate = 2000;
	datarate = 0;
	dataratems = 0;
	datarateX = 0; // added by SiRoB - Better datarate limit
	datarateave = 0;
	bannedcount = 0;
	counter=0;
	successfullupcount = 0;
	failedupcount = 0;
	totaluploadtime = 0;
	m_nUpDataRateMSOverhead = 0;
	m_nUpDatarateOverhead = 0;
	m_nUpDataOverheadSourceExchange = 0;
	m_nUpDataOverheadFileRequest = 0;
	m_nUpDataOverheadOther = 0;
	m_nUpDataOverheadServer = 0;
	m_nUpDataOverheadSourceExchangePackets = 0;
	m_nUpDataOverheadFileRequestPackets = 0;
	m_nUpDataOverheadOtherPackets = 0;
	m_nUpDataOverheadServerPackets = 0;
	m_nLastStartUpload = 0;
	statsave=0;
	AvgRespondTime[0]=500; // SUC mod by [lovelace]
	AvgRespondTime[1]=theApp.glob_prefs->GetSUCPitch()/3; // SUC mod by [lovelace]
	MaxVUR=0;//SUC [lovelace]
	//[Bloodymad Scoring.ReleaseSlots]
	m_nReleaseSlotMap = 0x0;
	m_nReleaseSlotIndex = 1;
	m_nReleaseSlotCount = 0;
	// -khaos--+++>
	iupdateconnstats=0;
	// <-----khaos-
	// By BadWolf - Accurate Speed Measurement
	sumavgTick = 0; // added by SiRoB
	sumavgUDRO = 0;
	sendperclient = 0;
	uLastAcceptNewClient = ::GetTickCount();
	sumavgdata = 0;
	m_delay = ::GetTickCount();
	m_delaytmp = 0;
	// END By BadWolf - Accurate Speed Measurement
 	emuleclienttopver=0; //added by milobac: Anti Leecher/Fake Clients
}

void CUploadQueue::AddUpNextClient(CUpDownClient* directadd){
	POSITION toadd = 0;
	POSITION toaddlow = 0;
	uint32	bestscore = 0;
	uint32  bestlowscore = 0;
	CUpDownClient* newclient;
	// select next client or use given client
	if (!directadd){
		//[Bloodymad Scoring.MultiQueue.LowId]
		do { // until we find a not-LowID client
		bestscore=0; bestlowscore=0;
		POSITION pos1, pos2;
		for (pos1 = waitinglist.GetHeadPosition();( pos2 = pos1 ) != NULL;){
			waitinglist.GetNext(pos1);
			CUpDownClient* cur_client =	waitinglist.GetAt(pos2);
			// clear dead clients
			ASSERT ( cur_client->GetLastUpRequest() );
			if ((::GetTickCount() - cur_client->GetLastUpRequest() > MAX_PURGEQUEUETIME) || !theApp.sharedfiles->GetFileByID(cur_client->GetUploadFileID()) ){
				RemoveFromWaitingQueue(pos2,true);	
				if (!cur_client->socket)
					cur_client->Disconnected();
				continue;
			}
			// finished clearing
			uint32 cur_score = cur_client->GetScore(true);
			if ( cur_score > bestscore){
				bestscore = cur_score;
				toadd = pos2;
			} else {
				cur_score = cur_client->GetScore(false);
				if ((cur_score > bestlowscore) && !cur_client->AddNextConnect){
					bestlowscore = cur_score;
				toaddlow = pos2;
			}
		}
		}
		
		if (bestlowscore > bestscore){
			newclient = waitinglist.GetAt(toaddlow);
			newclient->AddNextConnect = true;

			//[Bloodymad Scoring.MultiQueue.LowId]
			//[Bloodymad Scoring.EstWaiting.Send]
			CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->GetUploadFileID());
			if (reqfile)
				reqfile->statistic.RegisterReservedSlot(newclient->GetWaitTime());
			//[Bloodymad Scoring.ReleaseSlots]
			AdjustReleaseSlots(reqfile && (reqfile->GetUpPriority()==PR_RELEASE));
		}
		if (!toadd)
			return;
		} while (bestlowscore>bestscore); // end do-while statement
		newclient = waitinglist.GetAt(toadd);
		lastupslotHighID = true; // VQB LowID alternate
		//theApp.emuledlg->AddLogLine(true,"Added High ID: " + (CString)newclient->GetUserName()); // VQB:  perhaps only add to debug log?
		RemoveFromWaitingQueue(toadd, true);
		theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
	}
	else {
		newclient = directadd;
		/*if (!IsDownloading(newclient)){
            if (newclient->HasLowID())
                theApp.emuledlg->AddLogLine(true,"DirectAdd:  LowID: " + (CString)newclient->GetUserName());
			else
                theApp.emuledlg->AddLogLine(true,"DirectAdd:  HighID: " + (CString)newclient->GetUserName());
		}*/
	}

	if (IsDownloading(newclient)){
		return;
	}
	// tell the client that we are now ready to upload
	if (!newclient->socket || !newclient->socket->IsConnected()){
		newclient->SetUploadState(US_CONNECTING);
		newclient->TryToConnect(true);
	}
	else{
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		newclient->socket->SendPacket(packet,true);
		newclient->SetUploadState(US_UPLOADING);
	}
	newclient->SetUpStartTime();
	newclient->ResetSessionUp();
	uploadinglist.AddTail(newclient);
	
	// statistic
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->GetUploadFileID());

	//[Bloodymad Scoring.MultiQueue.LowId]
	if (!newclient->AddNextConnect) {
		//[Bloodymad Scoring.EstWaiting.Send]
		CKnownFile* rfile = theApp.sharedfiles->GetFileByID(newclient->GetUploadFileID());
		if (rfile)
			rfile->statistic.RegisterReservedSlot(newclient->GetWaitTime());
	//[Bloodymad Scoring.ReleaseSlots]
	AdjustReleaseSlots(reqfile && (reqfile->GetUpPriority()==PR_RELEASE));
	} else
		newclient->AddNextConnect = false;

	if (reqfile){
		reqfile->statistic.AddAccepted();
	}
		
	theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(newclient);

}

void CUploadQueue::Process(){
	//>>>Entierly modified by SiRoB
	uint32 tick_avg = 100;
	DWORD deltmp = ::GetTickCount();
	if (m_delaytmp==0) m_delaytmp=deltmp-100;
	m_delay = deltmp - m_delaytmp ;
	m_delaytmp = deltmp;
	TransferredData newitem2 = {m_delay, deltmp};
	m_AvarageTick_list.AddTail(newitem2);
	sumavgTick+=m_delay;
	while (m_AvarageTick_list.GetCount() > 600)
		sumavgTick-=m_AvarageTick_list.RemoveHead().datalen;
	if (m_AvarageTick_list.GetCount() > 0) tick_avg = sumavgTick/m_AvarageTick_list.GetCount();
	
	TransferredData newitem = {datarateX, deltmp};
	avarage_dr_list.AddTail(newitem);
	dataratems+=datarateX;
	datarateX = 0;
	while (((avarage_dr_list.GetTail().timestamp - avarage_dr_list.GetHead().timestamp) > 15000)&&(avarage_dr_list.GetCount() > 0))
		dataratems-=avarage_dr_list.RemoveHead().datalen;
	if (avarage_dr_list.GetCount() > 1) {
		uint32 deltat = (avarage_dr_list.GetTail().timestamp - avarage_dr_list.GetHead().timestamp);
		datarate = 1000 * dataratems / ((deltat>14500)?deltat:14500); //modified by SiRoB - Don't Know why timestamp could be equal
	} else
		datarate = 0;
	if (AcceptNewClient() && waitinglist.GetCount()){
		m_nLastStartUpload = ::GetTickCount();
		AddUpNextClient();
	}

	if (!uploadinglist.GetCount()) {
		return;
	}

	int16 LANclientsrdy = 0;  // LANCAST (moosetea) the number of lan clients ready to recieve more data NEW CODE
	int16 clientsrdy = 0;
	int16 clientsbusy = 0;
	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		CUpDownClient* cur_client = uploadinglist.GetAt(pos);
		// LANCAST (moosetea) - We count lancast clients separatly, so we dont steal bw from normal uploads
		if ((cur_client->socket) && (!cur_client->socket->IsBusy()) && cur_client->HasBlocks()){
			if (cur_client->isOnLAN())
				LANclientsrdy++;
			else
				clientsrdy++;
		}
	}
	// LANCAST (moosetea) - Estimate the lan data rate, adjusts down much more quickly, at higher speeds
	if (!LANclientsrdy){
		estLANdatarate -= 200;
		if (estLANdatarate < 100)
			estLANdatarate = 100;
		LANclientsrdy++;
	}
	else{
		estLANdatarate += 200;
	}

	uint32 sendperclient;
	uint32 maxupload_real;
	if (theApp.glob_prefs->IsSUCEnabled() && theApp.glob_prefs->IsAutoUpEnabled())
		maxupload_real = (uint32) GetMaxVUR();
	else if (theApp.glob_prefs->IsAMUCEnabled() && theApp.glob_prefs->IsAutoUpEnabled())
		maxupload_real = (uint32) theApp.AMUC->GetEstimatedUpload(clientsrdy);
	else
		maxupload_real = 1024*((app_prefs->GetMaxUpload()==UNLIMITED)?app_prefs->GetMaxGraphUploadRate():app_prefs->GetMaxUpload());;
	
	uint32 maxupload = maxupload_real / 50;
	if(maxupload<200) maxupload = 200;
	
	if (!clientsrdy){
		if ((estadatarate > maxupload)&& (10*estadatarate>9*maxupload_real)) estadatarate -= maxupload;
		sendperclient = 0;
	} else{
		if ((clientsbusy/clientsrdy) <= 1){
			estadatarate += maxupload;
			if(estadatarate > maxupload_real)
				estadatarate=maxupload_real;
		}
		uint32 estadatarate_tmp = estadatarate * m_delay / 100;
		if (estadatarate_tmp > (tick_avg * maxupload_real / 100))
			estadatarate_tmp = tick_avg * maxupload_real / 100;
		sendperclient = estadatarate_tmp / (10*clientsrdy);
		if ((clientsrdy+clientsbusy)==uploadinglist.GetCount())
			sendperclient = min(sendperclient,theApp.glob_prefs->GetMaxUpSlot()*tick_avg/1000);
	}
	uint32 sendperLANclient = estLANdatarate/LANclientsrdy; // LANCAST (moosetea) calculate the lan client send rate
	
	POSITION pos1,pos2;
	for (pos1 = uploadinglist.GetHeadPosition();( pos2 = pos1 ) != NULL; ){
		uploadinglist.GetNext(pos1);
		CUpDownClient* cur_client = uploadinglist.GetAt(pos2);
		// LANCAST (moosetea) - We send data to lancast users at a much higher speed
		if (cur_client->isOnLAN())
			cur_client->SendBlockData(sendperLANclient);	// We dont count lancast data as part of overall datarate!
		else
		datarateX += cur_client->SendBlockData(sendperclient);
	}
	// START enkeyDEV(th1) -L2HAC- lowid side, automatic callback phase
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID())
	{
		for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
			CUpDownClient* cur_client = waitinglist.GetAt(pos);
			if (cur_client->IsL2HACEnabled()
				&& cur_client->GetLastL2HACExecution()
				&& cur_client->GetL2HACTime()
				&& (::GetTickCount() - cur_client->GetLastL2HACExecution()) > cur_client->GetL2HACTime())
			{
				if (theApp.listensocket->TooManySockets() && !(cur_client->socket && cur_client->socket->IsConnected()) )
					cur_client->SetLastL2HACExecution(::GetTickCount() - cur_client->GetL2HACTime() + (uint32)ROUND(((float)rand()/RAND_MAX)*300000));
				else
				{
					cur_client->DisableL2HAC();
					if (!cur_client->HasLowID() && cur_client->GetL2HACTime())
						cur_client->TryToConnect();
				}
			}
		}
	}
	// END enkeyDEV(th1) -L2HAC-
	//<<<Entierly modified by SiRoB
	};

bool CUploadQueue::AcceptNewClient(bool force){ // modified by SiRoB
	// check if we can allow a new client to start downloading from us
	if (uploadinglist.GetCount() < MIN_UP_CLIENTS_ALLOWED) return true;
	if (!force && ((::GetTickCount() - m_nLastStartUpload) < 5000 )) return false;//Changed By Yun.SF3
	if (uploadinglist.GetCount() >= theApp.glob_prefs->GetMaxUploadSlots())	return false;
	if ((10*datarate<=9*estadatarate)&&((UPLOAD_LOW_CLIENT_DR*(uint32)(uploadinglist.GetCount()+1))<=estadatarate)) return true;
	if (theApp.glob_prefs->GetMaxUpSlot()*(uint32)(uploadinglist.GetCount()+1)<=estadatarate) return true;
		return false;
}

CUploadQueue::~CUploadQueue(){
	KillTimer(0,141);
}

CUpDownClient* CUploadQueue::GetWaitingClientByIP_UDP(uint32 dwIP, uint16 nUDPPort){
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;){
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP() && nUDPPort == cur_client->GetUDPPort())
			return cur_client;
	}
	return 0;
}

#ifdef _DEBUG
CUpDownClient* CUploadQueue::GetWaitingClientByIP(uint32 dwIP){
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;){
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP())
			return cur_client;
	}
	return 0;
}
#endif

void CUploadQueue::UpdateBanCount(){
	int count=0;
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if(cur_client->IsBanned())
			count++;
	}
	SetBanCount(count);
}
void CUploadQueue::AddClientToQueue(CUpDownClient* client, bool bIgnoreTimelimit){
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID()
		&& !theApp.serverconnect->IsLocalServer(client->GetServerIP(),client->GetServerPort())
		&& client->GetDownloadState() == DS_NONE && !client->IsFriend()
		&& GetWaitingUserCount() > 50)
		return;
	//(filtering invalid eMule clients)
	if (!client->GetMuleVersion() && (client->GetClientSoft()==SO_EMULE || client->GetClientSoft()==SO_OLDEMULE) && (client->GetVersion()==60 || !client->GetVersion()))
	return;

	if (!client->ExtProtocolAvailable() && client->GetClientSoft()==SO_EMULE && (client->GetVersion()==60 || !client->GetVersion()))
	return;
	//end (filtering invalid eMule clients)
	client->AddAskedCount();
	client->SetLastUpRequest();
	// START enkeyDEV(th1) -L2HAC- lowid side
	client->SetLastL2HACExecution();
	if (!client->HasLowID() && client->GetL2HACTime()) client->EnableL2HAC();
	// END enkeyDEV(th1) -L2HAC-
	// LANCAST (moosetea) - We ignore any ban LAN clients may have :)
	if (!bIgnoreTimelimit && !client->isOnLAN()){
		if (client->IsBanned()){
			if (::GetTickCount() - client->GetBanTime() > 54000000){
				client->UnBan();
			}
			else
				return;
		}
		client->AddRequestCount(client->GetUploadFileID());
	}
	// check for double
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if (cur_client == client){	//already on queue
			// VQB LowID Slot Patch -- note:  should add limit so only if #slots < UL -or- UL+1 for Low UL (?)
			if (client->AddNextConnect && AcceptNewClient(true)){
				if (lastupslotHighID) {
					//[Bloodymad Scoring.EstWaiting.Send]
					//[Bloodymad Scoring.ReleaseSlots]
					//client->AddNextConnect = false; // Moved into AddUpNextClient
				RemoveFromWaitingQueue(client, true);
				AddUpNextClient(client);
					lastupslotHighID = false; // LowID alternate
					// theApp.emuledlg->AddLogLine(true,"Added Low ID User On Reconnect: " + (CString)client->GetUserName()); // VQB:  perhaps only add to debug log?
				return;
			}
				else
					;// theApp.emuledlg->AddLogLine(true, "Skipped LowID User on Reconnect: " + (CString)client->GetUserName());
			}
			// VQB end
			client->SendRankingInfo();
			theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(client);
			return;			
		}
		else if ( client->Compare(cur_client) ) {
			// another client with same ip or hash
			if (client->Trust()>=cur_client->Trust())//>>lovelace (AntiCreditTheft) 
			{
				theApp.emuledlg->AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );
				if (client->Trust()>cur_client->Trust())
				{
          theApp.emuledlg->AddLogLine(false,"AntiCreditTheft [lovelace]: client '%s' is outdated or using a stolen userhash and has been removed.",cur_client->GetUserName()); 
					if (cur_client->socket && cur_client->GetUploadState()){
            /* char* message = "AntiCreditTheft [lovelace]: You've been blocked because of using stolen userhashs.";
						uint16 mlen = (uint16)strlen(message);
						Packet* packet = new Packet(OP_MESSAGE,mlen+2);
						memcpy(packet->pBuffer,&mlen,2);
						memcpy(packet->pBuffer+2,message,mlen);
						cur_client->socket->SendPacket(packet,true,true);
            theApp.emuledlg->AddDebugLogLine(false,CString("Message to ")+CString(cur_client->GetUserName())+CString(": ")+CString(message),cur_client->GetUserName()); */
					}
				}
				if (!client->credits)
				{
					uchar key[16];
					memcpy(key,client->GetUserHash(),16);
					client->credits = theApp.clientcredits->GetCredit(key);
				}
				if (cur_client->GetUserID()!=client->GetUserID())
				{
					client->SetTrustedTransfer(0);
					if (client->IsBanned()) client->UnBan();
					if (GetTickCount()>client->credits->GetTrustTime(0))
						client->credits->SetTrustTime(0,0);
				}
				RemoveFromWaitingQueue(pos,true);	
				if (!cur_client->socket)
					cur_client->Disconnected();	
				return;
			}
			else
			{
				theApp.emuledlg->AddLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),client->GetUserName() );
        theApp.emuledlg->AddLogLine(false,"AntiCreditTheft [lovelace]: client '%s' is probably using a stolen userhash and has been blocked.",client->GetUserName()); 
				if (client->socket && client->GetUploadState()){
          /* char* message = "AntiCreditTheft [lovelace]: You've been blocked because of probably using stolen userhashs.";
					uint16 mlen = (uint16)strlen(message);
					Packet* packet = new Packet(OP_MESSAGE,mlen+2);
					memcpy(packet->pBuffer,&mlen,2);
					memcpy(packet->pBuffer+2,message,mlen);
					client->socket->SendPacket(packet,true,true);
          theApp.emuledlg->AddDebugLogLine(false,CString("Message to ")+CString(client->GetUserName())+CString(": ")+CString(message),client->GetUserName()); */
				}
				if (!cur_client->credits)
				{
					uchar key[16];
					memcpy(key,cur_client->GetUserHash(),16);
					cur_client->credits = theApp.clientcredits->GetCredit(key);
				}
				if (cur_client->GetUserID()!=client->GetUserID())
				{
					cur_client->SetTrustedTransfer(0);
					if (cur_client->IsBanned()) cur_client->UnBan();
					if (GetTickCount()>cur_client->credits->GetTrustTime(0))
						cur_client->credits->SetTrustTime(0,0);
				}
				RemoveFromWaitingQueue(client,true);	
				if (!client->socket)
					client->Disconnected();	
				return;
			}//<<lovelace (AntiCreditTheft) 
		}
	}
	// done

	// Add clients server to list.
	if (theApp.glob_prefs->AddServersFromClient()){
		in_addr host;
		host.S_un.S_addr = client->GetServerIP();
		CServer* srv = new CServer(client->GetServerPort(), inet_ntoa(host));
		srv->SetListName(srv->GetAddress());

		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(srv, true))
			delete srv;
		/*else
		theApp.emuledlg->AddLogLine(false,"Added new server: %s:%d", srv->GetFullIP(), srv->GetPort());*/
	}

	// statistic values
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetUploadFileID());
	if (reqfile)
		reqfile->statistic.AddRequest();
	// TODO find better ways to cap the list
	if ((uint32)waitinglist.GetCount() > (theApp.glob_prefs->GetQueueSize()+bannedcount))
		return;
	if (client->IsDownloading()){
		// he's already downloading and wants probably only another file
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		client->socket->SendPacket(packet,true);
		return;
	}

	// LANCAST (moosetea) - Lan users bypass the queue
	if ((waitinglist.IsEmpty() && AcceptNewClient()) || client->isOnLAN()){
		AddUpNextClient(client);
		m_nLastStartUpload = ::GetTickCount();
	}
	else{
		waitinglist.AddTail(client);
		client->SetUploadState(US_ONUPLOADQUEUE);
		client->SendRankingInfo();
		theApp.emuledlg->transferwnd.queuelistctrl.AddClient(client);
		theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
	}
}

bool CUploadQueue::RemoveFromUploadQueue(CUpDownClient* client, bool updatewindow){
	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		if (client == uploadinglist.GetAt(pos)){
			if (updatewindow)
				theApp.emuledlg->transferwnd.uploadlistctrl.RemoveClient(uploadinglist.GetAt(pos));
			uploadinglist.RemoveAt(pos);
			if( client->GetTransferedUp() ){
				successfullupcount++;
				totaluploadtime += client->GetUpStartTimeDelay()/1000;
			}
			else
				failedupcount++;
			client->SetUploadState(US_NONE);
			client->ClearUploadBlockRequests();
//			CKnownFile* reqfile = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
			//			if( reqfile )
			//				reqfile->SubQueuedCount();
			//			client->SetUploadFileID(NULL);
			return true;
		}
	}
	return false;
}

uint32 CUploadQueue::GetAverageUpTime(){
	if( successfullupcount ){
		return totaluploadtime/successfullupcount;
	}
	return 0;
}

bool CUploadQueue::RemoveFromWaitingQueue(CUpDownClient* client, bool updatewindow){
	POSITION pos = waitinglist.Find(client);
	if (pos){
		RemoveFromWaitingQueue(pos,updatewindow);
		if (updatewindow)
			theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
		return true;
	}
	else
		return false;
}

void CUploadQueue::RemoveFromWaitingQueue(POSITION pos, bool updatewindow){	
	CUpDownClient* todelete = waitinglist.GetAt(pos);
	waitinglist.RemoveAt(pos);
	if( todelete->IsBanned() )
		todelete->UnBan();
	if (updatewindow)
		theApp.emuledlg->transferwnd.queuelistctrl.RemoveClient(todelete);
	todelete->SetUploadState(US_NONE);
}


bool CUploadQueue::CheckForTimeOver(CUpDownClient* client){
	if( client->GetUpStartTimeDelay() > 3600000 ){ // Try to keep the clients from downloading for ever.
		theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to excessive time.", client->GetUserName());
		return true;
	}
	// For some reason, some clients can continue to download after a chunk size.
	// Are they redownloading the same chunk over and over????
	if( client->GetSessionUp() > 10485760 ){
		theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to excessive transfered amount.", client->GetUserName());
		return true;
	}
	//}
	//else				//removed by Roman2K (always uplaod full chunks)
	//{
	//	// Cache current client score
	//	const uint32 score = client->GetScore(true, true);
	//	 
	//	// Check if another client has a bigger score
	//	for(POSITION pos = waitinglist.GetHeadPosition(); pos != 0; )
	//		if(score < waitinglist.GetNext(pos)->GetScore(true, false)){
	//			theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to score.", client->GetUserName());
	//			return true;
	//		}
	//}
	return false;
}

void CUploadQueue::DeleteAll(){
	waitinglist.RemoveAll();
	uploadinglist.RemoveAll();
}

//[Bloodymad Scoring.EstWaiting.Send]
// Whole function rewritten
uint16 CUploadQueue::GetWaitingPosition(CUpDownClient* client){
	if (!IsOnUploadQueue(client))
		return 0;

	CKnownFile* rfile = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
	if (!rfile) // Unknown file requested
		return 65535;

	float myscore = client->GetUserScore();
	float myscoreratio = client->credits->GetScoreRatio();

	// Get some informations about the queue
	float prelowscore = 0.0, posthiscore = 0.0;
	int precnt = 0, postcnt = 0, prelowcnt = 0, posthicnt = 0;

	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* otherclient = waitinglist.GetAt(pos);
		if ((*otherclient->GetUploadFileID()==*client->GetUploadFileID()) && (otherclient!=client)){
			// Our queue
			float otherscoreratio = otherclient->credits->GetScoreRatio();
			if (otherclient->GetUserScore()>myscore){
				precnt++;
				if (otherscoreratio<myscoreratio){
					prelowcnt++;
					prelowscore += otherscoreratio;
				}
			}
			else {
				postcnt++;
				if (otherscoreratio>myscoreratio){
					posthicnt++;
					posthiscore += otherscoreratio;
				}
			}
		}
	}

	// We can gain/loose position by credits.
	// Assuming everything is equally distributed over the queue.
	int rank = precnt + 1  // 1 => ourself
		- (prelowcnt? (prelowcnt-prelowcnt/(1+myscoreratio-(prelowscore/prelowcnt)))*(float)prelowcnt/precnt : 0)
		+ (posthicnt? (posthicnt-posthicnt/(1.0+(posthiscore/posthicnt)-myscoreratio))*(float)posthicnt/postcnt : 0);
	ASSERT(rank>=0);
	ASSERT(rank>=precnt-prelowcnt);
	ASSERT(rank<=precnt+posthicnt+1);

	//TODO: Missing: Amount of people that disconnect before they reach the queue head

	// We send a estimated waiting time. One point = a half minute
	// So QR=120 one hour waiting expected
	float halfmins = rfile->statistic.GetTimeToWait(rank)/30000.0;

	if (halfmins>=65535) // Over 22 days waiting
		return 65535;
	if (client->AddNextConnect) // Already accepted LowId
		return 0;
	if (halfmins<1) // Never send QR=0 if not downloading. Would confuse.
		return 1;
	return (uint16)halfmins;
}

void CUploadQueue::CompUpDatarateOverhead(){
	// Patch by BadWolf - Accurate datarate Calculation
	TransferredData newitem = {m_nUpDataRateMSOverhead,::GetTickCount()};
	this->m_AvarageUDRO_list.AddTail(newitem);
	sumavgUDRO += m_nUpDataRateMSOverhead;
	m_nUpDataRateMSOverhead = 0;
	while (((m_AvarageUDRO_list.GetTail().timestamp - m_AvarageUDRO_list.GetHead().timestamp) > 15000)&&(m_AvarageUDRO_list.GetCount() > 0))
		sumavgUDRO -= m_AvarageUDRO_list.RemoveHead().datalen;
	if(m_AvarageUDRO_list.GetCount() > 1){
		uint32 deltat = (m_AvarageUDRO_list.GetTail().timestamp - m_AvarageUDRO_list.GetHead().timestamp);
		m_nUpDatarateOverhead = 1000 * sumavgUDRO / ((deltat>14500)?deltat:14500);
	}else
		m_nUpDatarateOverhead = 0;
	// END Patch by BadWolf	
}

VOID CALLBACK CUploadQueue::UploadTimer(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	// NOTE: Always handle all type of MFC exceptions in TimerProcs - otherwise we'll get mem leaks
	try
	{
	// Barry - Don't do anything if the app is shutting down - can cause unhandled exceptions
	if (!theApp.emuledlg->IsRunning())
		return;

	theApp.uploadqueue->Process();
	theApp.downloadqueue->Process();
	theApp.uploadqueue->CompUpDatarateOverhead();
	theApp.downloadqueue->CompDownDatarateOverhead();
	counter++;

	// one second
	if (counter >= 10){
		counter=0;
		theApp.clientcredits->Process();
		theApp.serverlist->Process();
		theApp.friendlist->Process();
		if( theApp.serverconnect->IsConnecting() && !theApp.serverconnect->IsSingleConnect() )
			theApp.serverconnect->TryAnotherConnectionrequest();

		theApp.emuledlg->statisticswnd.UpdateConnectionsStatus();
		if (theApp.glob_prefs->WatchClipboard4ED2KLinks()) theApp.emuledlg->searchwnd.SearchClipBoard();		
		if (theApp.serverconnect->IsConnecting()) theApp.serverconnect->CheckForTimeout();

			// -khaos--+++> Update connection stats...
			iupdateconnstats++;
			// 2 seconds
			if (iupdateconnstats>=2) {
				iupdateconnstats=0;
				theApp.emuledlg->statisticswnd.UpdateConnectionStats((float)theApp.uploadqueue->GetDatarate()/1024, (float)theApp.downloadqueue->GetDatarate()/1024);
			}
			// <-----khaos-

		// display graphs
		if (theApp.glob_prefs->GetTrafficOMeterInterval()>0) {
			igraph++;

			if (igraph >= (uint32)(theApp.glob_prefs->GetTrafficOMeterInterval()) ) {
				igraph=0;
				//theApp.emuledlg->statisticswnd.SetCurrentRate((float)(theApp.uploadqueue->Getavgupload()/theApp.uploadqueue->Getavg())/1024,(float)(theApp.uploadqueue->Getavgdownload()/theApp.uploadqueue->Getavg())/1024);
				theApp.emuledlg->statisticswnd.SetCurrentRate((float)(theApp.uploadqueue->GetDatarate())/1024,(float)(theApp.downloadqueue->GetDatarate())/1024);
				//theApp.uploadqueue->Zeroavg();
			}
		}
		if (theApp.emuledlg->activewnd == &theApp.emuledlg->statisticswnd && theApp.emuledlg->IsWindowVisible() )  {
			// display stats
			if (theApp.glob_prefs->GetStatsInterval()>0) {
				istats++;

				if (istats >= (uint32)(theApp.glob_prefs->GetStatsInterval()) ) {
					istats=0;
					theApp.emuledlg->ShowStatistics();
				}
			}
		}
		//save rates every second
		theApp.emuledlg->statisticswnd.RecordRate();

		sec++;
		// 5 seconds
		if (sec>=5) {

#ifdef _DEBUG
			if (!AfxCheckMemory()) AfxDebugBreak();
#endif

			sec = 0;
			theApp.listensocket->Process();
			theApp.OnlineSig(); // Added By Bouc7 
			theApp.emuledlg->ShowTransferRate();
			
			// update cat-titles with downloadinfos only when needed
			if (theApp.glob_prefs->ShowCatTabInfos() && 
				theApp.emuledlg->activewnd==&theApp.emuledlg->transferwnd && 
				theApp.emuledlg->IsWindowVisible()) 
					theApp.emuledlg->transferwnd.UpdateCatTabTitles();
			
			if (theApp.glob_prefs->IsSchedulerEnabled()) theApp.scheduler->Check();
		}

		statsave++;
			// -khaos--+++>
			// 60 seconds
			if (statsave>=60) {
				// Time to save our cumulative statistics.
			statsave=0;
				
			// CPreferences::SaveStats() in Preferences.cpp
				// This function does NOT update the tree!
				theApp.glob_prefs->SaveStats();
			// <-----khaos-
		}
	}
	}
	CATCH_DFLT_EXCEPTIONS("CUploadQueue::UploadTimer")
}

CUpDownClient* CUploadQueue::GetNextClient(CUpDownClient* lastclient){
	if (waitinglist.IsEmpty())
		return 0;
	if (!lastclient)
		return waitinglist.GetHead();
	POSITION pos = waitinglist.Find(lastclient);
	if (!pos){
		TRACE("Error: CServerList::GetNextClient");
		return waitinglist.GetHead();
	}
	waitinglist.GetNext(pos);
	if (!pos)
		return NULL;
	else
		return waitinglist.GetAt(pos);
}

void CUploadQueue::FindSourcesForFileById(CTypedPtrList<CPtrList, CUpDownClient*>* srclist, uchar* filehash) {
	POSITION pos;

	pos = uploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = uploadinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}

	pos = waitinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = waitinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}
}

//[Bloodymad Scoring.ReleaseSlots]
// Should the next slot be a release-slot?
bool CUploadQueue::ReleaseSlotReady() {
	return 
		// too few releases currently downloading
		(m_nReleaseSlotCount<theApp.glob_prefs->GetReleaseSlots()) ||
		// or next free slot will be a release slot
		((m_nReleaseSlotCount==theApp.glob_prefs->GetReleaseSlots()) &&
		(m_nReleaseSlotMap & m_nReleaseSlotIndex));
}

// Called if a new upload is added
void CUploadQueue::AdjustReleaseSlots(bool newReleaseAdded){
	if (ReleaseSlotReady())
		theApp.emuledlg->AddDebugLogLine(false,"Release Requested...");
	if (newReleaseAdded){
		if (!(m_nReleaseSlotMap & m_nReleaseSlotIndex))
			m_nReleaseSlotCount++, ASSERT(m_nReleaseSlotCount<=5);
		m_nReleaseSlotMap |= m_nReleaseSlotIndex;
		theApp.emuledlg->AddDebugLogLine(false,"Added Release (Now %i RSlots, %#x in map %#x)",m_nReleaseSlotCount, m_nReleaseSlotIndex, m_nReleaseSlotMap);
	}
	else{
		if (m_nReleaseSlotMap & m_nReleaseSlotIndex)
			m_nReleaseSlotCount--, ASSERT(m_nReleaseSlotCount>=0);
		m_nReleaseSlotMap &= ~m_nReleaseSlotIndex;
		theApp.emuledlg->AddDebugLogLine(false,"Added NOT-Release (Now %i RSlots, %#x in map %#x)",m_nReleaseSlotCount, m_nReleaseSlotIndex, m_nReleaseSlotMap);
	}
	m_nReleaseSlotIndex*=2;
	if (m_nReleaseSlotIndex==0x0020) // We look at five slots == five bits
		m_nReleaseSlotIndex=1;
}
